app/routes.php
<?php

/*
|--------------------------------------------------------------------------
| Application Routes
|--------------------------------------------------------------------------
|
| Here is where you can register all of the routes for an application.
| It's a breeze. Simply tell Laravel the URIs it should respond to
| and give it the Closure to execute when that URI is requested.
|
*/

Route::get('/', 'HomeController@index');


Route::get('/login', 'SessionsController@create');


Route::resource('user', 'UserController');

Route::get('logout', 'SessionsController@logout' );


route::post('active', 'SessionsController@activeUser');

//fruits
Route::post('fruit', array('before' => 'storeFruit|checkMerchant', 'uses' => 'FruitsController@store'));
Route::put('fruit/{fruit}', array('before' => 'storeFruit|updDelFruit|checkMerchant', 'uses' => 'FruitsController@update'));
Route::post('fruit/{fruit}', array('before' => 'updDelFruit|checkMerchant', 'uses' => 'FruitsController@destroy'));




//stock, baskets
Route::get('stock', array('before' => 'checkMerchant', 'uses' => 'StockController@index'));
Route::post('stock', array('before' => 'checkMerchant', 'uses' => 'StockController@store'));
Route::get('stock/{id}', array('before' => 'checkMerchant|updDelBasket', 'uses' => 'StockController@show'));
Route::post('stock/{id}', array('before' => 'checkMerchant|updDelBasket', 'uses' => 'StockController@destroy'));


//Shops, HomeCotroller

Route::get('shop/fruits', 'HomeController@fruitsAll');
Route::post('shop/fruits', 'HomeController@getFruitsBy');



Route::get('shop/baskets', 'HomeController@getBaskets');
Route::post('shop/baskets', 'HomeController@getBasketsBy');




Route::post('/connection', 'SessionsController@connection');
	

app/models/User.php
<?php

use Illuminate\Auth\UserTrait;
use Illuminate\Auth\UserInterface;
use Illuminate\Auth\Reminders\RemindableTrait;
use Illuminate\Auth\Reminders\RemindableInterface;

class User extends Eloquent implements UserInterface, RemindableInterface {

	use UserTrait, RemindableTrait;

	/**
	 * The database table used by the model.
	 *
	 * @var string
	 */
	protected $table = 'users';

	protected $fillable = array('email', 'lname', 'password', 'fname', 'admin', 'active');

	public $fillableFields = array('fname','lname','email', 'password','admin', 'active');


	/**
	 * The attributes excluded from the model's JSON form.
	 *
	 * @var array
	 */
	protected $hidden = array('password', 'remember_token');


	//RELATIONSHIPS
	
    public function basket()
    {
        return $this->hasMany('Basket');
    }


	    


















}

app/controllers/UserController.php
<?php

class UserController extends \BaseController {

	/**
	 * Display a listing of the resource.
	 *
	 * @return Response
	 */
	public function index()
	{
		$users = User::all();
		return Response::json(["data"=>$users]);
	}

	/**
	 * Store a newly created resource in storage.
	 *
	 * @return Response
	 */
	public function store()
	{
		$input = array();
		$user = new User;
		if(Auth::check() && Auth::user()->admin >0)
		{
			if(null ==Input::get('admin'))
			{
				Input::merge(['admin' => 0]);
			}
			$array= array();
			foreach ($user->fillableFields as $key) {
					$array[$key] = Input::get($key);
			}
			if(Input::get('active') == null )
			{
				$array['active'] = 0;
			}

			$input['email'] = Input::get('email');

			$rules = array('email' => 'unique:users,email');
			$validator = Validator::make($input, $rules);
			if ($validator->fails()) {
				return Response::json(["error"=>true,
										"code"=>"??",
										"message"=>"email already used!"])   ;

			    
			}
			else {
			    $password= Hash::make(Input::get('password'));
				$user = User::create($array);
				$update = $user->update(array('password'=>$password));
				return Response::json(["error"=>false,
										"data"=>$user,
										"message  "=>$user->lname." created"])   ;	

			}
		}
		 else {
			return Response::json(array(
				"error"=>true,
				"code"=>"authorization",
				"message"=>"Vous n'avez pas les droits nécessaires pour créer un utilisateur, il faut être admin."
			));
		}	

		
		
	}


	/**
	 * Display the specified resource.
	 *
	 * @param  int  $id
	 * @return Response
	 */
	public function show($id)
	{
		if(null !== $id)
		{
			$user = User::find($id);
			return Response::json(['data'=>$user]);	
		}
		else
		{
			return Response::json(['error'=> true,
									]);
		}

	}


	/**
	 * Update the specified resource in storage.
	 *
	 * @param  int  $id
	 * @return Response
	 */
	public function update($id)
	{	
		if($id ==null)
		{
			return Response::json(["error"=>true, 
									"succes"=> false,
									"message"=>"Pas d'user spécifié"]);
		}
		if(Auth::user()->admin >0)
		{

		
			$user = User::find($id);
			$update = $user->update(Input::all());
			if($update)
			{	
				$password= Hash::make(Input::get('password'));
				$update = $user->update(array('password'=>$password));
				return Response::json(['error'=> false, 
										'data'=> $user
											]);

			}
			return Response::json(["error"=>true,
									"code"=>"Unknown",
									]);
		}
		return Response::json(['error'=> true,
								'code'=>'unautorized(ortho a verifier)',
								"message"=>"Vous devez etre admin pour une mise a jour user"
								]);
			
	}


	/**
	 * Remove the specified resource from storage.
	 *
	 * @param  int  $id
	 * @return Response
	 */
	public function destroy($id)
	{	

		if($id == null)
		{
			return Response::json(["error"=> true,
										"code"=>"unspecified",
										"message"=>"Unspecified user"

				]);
		}
		$succes= false;
		if(Auth::user()->admin == 0)
		{
			return  Response::json(array(
				"error"=>true,
				"code"=>"authorization",
				"message"=>"Vous n'avez pas les droits nécessaires pour effacer un utilisateur, il faut être admin."
			));

		}
		if( Auth::user()->id == $id)
		{
				 return Response::json(['succes' => $succes,
				 						"message"=>'You cant delete yourself'
				 		]);
		}
		$user = User::find($id);

		$succes =$user->delete($id);	

		return Response::json(['succes'=> $succes]);
	}




}

app/views/user/create.blade.php
@extends('user/edit')



@section('contentEdit')

{{--*/ $user = new User /*--}}

{{
	Form::model($user, array('route' => array("user.store", $user->id), 'method' => 'POST'))
}}




@stop

app/views/user/delete.blade.php
@extends('layout')


@section('content')
<h1> Delete ?</h1>

{{dd()}}

<h2>  {{ link_to_action('Usercontroler@destroy','Delete User' ) }}</h2>


@stop
	

app/views/user/edit.blade.php
@extends('user/editcreate')




@section('contentEdit')
<h1> Edit {{ $user->fname }} {{ $user->lname }} </h1>

{{ Form::model($user, array('route' => array("user.update", $user->id), 'method' => 'PUT')) }}



@stop

app/views/user/editcreate.blade.php
@extends('layout')




@section('forms')
@yield('contentEdit')



@foreach($user->fillableFields as &$value) 

	
	{{ Form::label($value, $value) }}

@if($value == 'password')
		{{ Form::password($value) }}


@elseif($value == 'admin')
	{{Form::checkbox($value, '1')}}

@else
	{{ Form::input('text' , $value) }}

	

@endif
<br>
<br>






@endforeach

{{ Form::submit('Submit') }}
{{ Form::close() }}




	@stop

app/views/user/index.blade.php
@extends('layout')



@section('content')

<h1> All Users </h1>
<table>
	<thead>

		<td>id </td><td>first Name </td> <td> Last name </td><td>  email address </td>  

	</thead>
<tbody>

@foreach ($users as $user)
<tr>
	<td> {{ $user->id}}</td><td>{{ $user->fname}} </td> 
	<td> {{ $user->lname}}</td><td> {{ $user->email}}</td> 
	<td>{{Form::open(array('action' => array('UserController@destroy', $user->id), 'method' => 'DELETE')) }}


		{{ Form::submit('DELETE') }}

		{{Form::close()}}


	</td> 
	<td>{{link_to_route('user.edit', "EDIT USER", $parameters = $user->id ) }}</td> 
	
</tr>

@endforeach
</tbody>
</table>





@stop